"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _core = require("@astql/core");

var _defaultParserInterface = _interopRequireDefault(require("@astql/core/utils/defaultParserInterface"));

var _package = _interopRequireDefault(require("php-parser/package.json"));

var ID = 'php-parser';
var defaultOptions = {
  parser: {
    extractDoc: true
  },
  ast: {
    withPositions: true
  }
};

var _default = (0, _extends2["default"])({}, _defaultParserInterface["default"], {
  id: ID,
  displayName: ID,
  version: _package["default"].version,
  homepage: _package["default"].homepage,
  locationProps: new Set(['loc']),
  typeProps: new Set(['kind']),
  loadParser: function loadParser(callback) {
    (0, _core.multipleRequire)(['php-parser'], callback);
  },
  parse: function parse(Engine, code) {
    var parser = new Engine(defaultOptions);
    return parser.parseCode(code, '');
  },
  getNodeName: function getNodeName(node) {
    return node.kind;
  },
  nodeToRange: function nodeToRange(node) {
    if (node.loc && node.loc.start && node.loc.end) {
      return [node.loc.start.offset, node.loc.end.offset];
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return key === 'body' || key === 'what' || key === 'items';
  }
});

exports["default"] = _default;